define(function(require){

	require("css!$UI/system/components/bootstrap/lib/css/bootstrap").load();
	require("css!./assets/admin/layout/css/layout").load();
	require("css!./assets/admin/layout/css/themes/blue").load({id: "style_color"});
	
	require("$UI/system/components/bootstrap/lib/js/bootstrap");
	require("$UI/system/lib/biz");
	require("./plugins.min");
	
	require("./metronic.min");
			
	var PortalRouteUtils = require("../utils");
	var biz = require('$UI/system/lib/biz');
	
	var $ = require("jquery");
	var justep = require("$UI/system/lib/justep");

	var mainPage = {
			url: '$model/UI2/portal/pc/main/main.w',
			process: "/portal/process/message/messageProcess", 
			activity: "mainActivity"},
		agentIndex = {
			url: '$UI/portal/pc/index.w',
			process: "/SA/OPM/system/systemProcess",
			activity: "mainActivity"
		},
		mainPageId = 'main';
	
	window.__justep.directConnectBiz = true;
	window.isPortalWindow = true;
	
	var Model = function(){
		this.openers = [];
				
		this.callParent();
		this.initRoute();
		
	};
	
	$.extend(Model.prototype,PortalRouteUtils);
	
	Model.prototype.openPage = function(path, options,fn){
		//兼容UI的API
		if(path.hasOwnProperty("label")&&path.hasOwnProperty("hidetreeable")){
			options = path;
			path = {};
			path.url = "$model/UI" + options.url;
			options.activity &&	(path.activity = options.activity);
			options.process && (path.process = options.process);
			
			fn = options.onload;
			options.title = options.label;
			delete options.url;
			delete options.activity;
			delete options.process;
			delete options.onload;
			delete options.label;
		}
	
		//兼容path为string的情况
		if(typeof path == 'string'){
			//一个url匹配多个菜单项目的情况
			var menuIndex = 0;
			if(path.charAt(path.length-2) === "+"){
				menuIndex = path.charAt(path.length-1);
				path = path.substring(0,path.length -2);
			}
			var matchMeuns = $('.page-sidebar-menu li>a[url="'+path+'"]');
			var el;
			if(matchMeuns.length > 1){
				el = matchMeuns.eq(menuIndex);
			}else if(matchMeuns.length == 1){
				el = matchMeuns.first();
			}
			if(el){
				path = {
		    			url: el.attr('url'),
		    			activity: el.attr('activity'),
		    			process: el.attr('process')
		    	};
				options = {title: el.attr('title')};
			}
		}
		return this._openPage(path, options, fn);
	};

	Model.prototype.initTheme = function(){
		this.initThemed = false;
		var options = {
			color: this.customizer.get("metronic/color"),
			layout: this.customizer.get("metronic/layout") || "fluid",
		    sidebar: this.customizer.get("metronic/sidebar") || "fixed",
		    header: this.customizer.get("metronic/header") || "fixed",
		    footer: this.customizer.get("metronic/footer") || "fixed",
		    sidebarPos: this.customizer.get("metronic/sidebarPos") || "left",
		    sidebarStyle: this.customizer.get("metronic/sidebarStyle") || "default",
		    sidebarMenu: this.customizer.get("metronic/sidebarMenu") || "accordion"
		}
		this.setTheme(options);
		this.initThemed = true;
	};
	
	Model.prototype.setTheme = function(options){
		this.setColor(options);
		delete options.color;
		this.setThemeOptions(options);
	};
	
	Model.prototype.setColor = function(options){
		var color = options.color;
		if(color){
	        $('#style_color').attr("href", Layout.getLayoutCssPath() + 'themes/' + color + ".css");
	        if (color == 'light2') {
	            $('.page-logo img').attr('src', Layout.getLayoutImgPath() + 'logo-invert.png');
	        } else {
	            $('.page-logo img').attr('src', Layout.getLayoutImgPath() + 'logo.png');
	        }
	        if(this.initThemed)
	        	this.customizer.save("metronic/color", options.color);
		}
	};
	
	Model.prototype.setThemeOptions = function(options){
        var layoutOption = options.layout;
        var sidebarOption = options.sidebar;
        var headerOption = options.header;
        var footerOption = options.footer;
        var sidebarPosOption = options.sidebarPos;
        var sidebarStyleOption = options.sidebarStyle;
        var sidebarMenuOption = options.sidebarMenu;
        var headerTopDropdownStyle = options.headerTopDropdown;

        if (sidebarOption == "fixed" && headerOption == "default") {
            alert('在头部不固定的情况下侧边拦固定是不支持的. 可以设置固定头, 固定侧边拦.');
//            $('.page-header-option', panel).val("fixed");
//            $('.sidebar-option', panel).val("fixed");
            sidebarOption = 'fixed';
            headerOption = 'fixed';
        }

        var resetLayout = function() {
            $(".body").
            removeClass("page-boxed").
            removeClass("page-footer-fixed").
            removeClass("page-sidebar-fixed").
            removeClass("page-header-fixed").
            removeClass("page-sidebar-reversed");

            $('.page-header > .page-header-inner').removeClass("container");

            if ($('.page-container').parent(".container").size() === 1) {
                $('.page-container').insertAfter('.body > .page-root > .clearfix');
            }

            if ($('.page-footer > .container').size() === 1) {
                $('.page-footer').html($('.page-footer > .container').html());
            } else if ($('.page-footer').parent(".container").size() === 1) {
                $('.page-footer').insertAfter('.page-container');
                $('.scroll-to-top').insertAfter('.page-footer');
            }

             $(".top-menu > .navbar-nav > li.dropdown").removeClass("dropdown-dark");

            $('.body > .page-root > .container').remove();
        };
        
        resetLayout(); // reset layout to default state

        if (layoutOption === "boxed") {
            $(".body").addClass("page-boxed");

            // set header
            $('.page-header > .page-header-inner').addClass("container");
            var cont = $('.body > .page-root > .clearfix').after('<div class="container"></div>');

            // set content
            $('.page-container').appendTo('.body > .page-root > .container');

            // set footer
            if (footerOption === 'fixed') {
                $('.page-footer').html('<div class="container">' + $('.page-footer').html() + '</div>');
            } else {
                $('.page-footer').appendTo('.body > .page-root > .container');
            }
        }

        if (this.lastSelectedLayout != layoutOption) {
            //layout changed, run responsive handler: 
            Metronic.runResizeHandlers();
        }
        this.lastSelectedLayout = layoutOption;

        //header
        if (headerOption === 'fixed') {
            $(".body").addClass("page-header-fixed");
            $(".page-root>.page-header").removeClass("navbar-static-top").addClass("navbar-fixed-top");
        } else {
            $(".body").removeClass("page-header-fixed");
            $(".page-root>.page-header").removeClass("navbar-fixed-top").addClass("navbar-static-top");
        }

        //sidebar
        if ($('.body').hasClass('page-full-width') === false) {
            if (sidebarOption === 'fixed') {
                $(".body").addClass("page-sidebar-fixed");
                $("page-sidebar-menu").addClass("page-sidebar-menu-fixed");
                $("page-sidebar-menu").removeClass("page-sidebar-menu-default");
                Layout.initFixedSidebarHoverEffect();
            } else {
                $(".body").removeClass("page-sidebar-fixed");
                $("page-sidebar-menu").addClass("page-sidebar-menu-default");
                $("page-sidebar-menu").removeClass("page-sidebar-menu-fixed");
                $('.page-sidebar-menu').unbind('mouseenter').unbind('mouseleave');
            }
        }

        // top dropdown style
        if (headerTopDropdownStyle === 'dark') {
            $(".top-menu > .navbar-nav > li.dropdown").addClass("dropdown-dark");
        } else {
            $(".top-menu > .navbar-nav > li.dropdown").removeClass("dropdown-dark");
        }

        //footer 
        if (footerOption === 'fixed') {
            $(".body").addClass("page-footer-fixed");
        } else {
            $(".body").removeClass("page-footer-fixed");
        }

        //sidebar style
        if (sidebarStyleOption === 'light') {
            $(".page-sidebar-menu").addClass("page-sidebar-menu-light");
        } else {
            $(".page-sidebar-menu").removeClass("page-sidebar-menu-light");
        }

        //sidebar menu 
        if (sidebarMenuOption === 'hover') {
            $(".page-sidebar-menu").addClass("page-sidebar-menu-hover-submenu");
        } else {
            $(".page-sidebar-menu").removeClass("page-sidebar-menu-hover-submenu");
        }

        //sidebar position
        if (Metronic.isRTL()) {
            if (sidebarPosOption === 'left') {
                $(".body").addClass("page-sidebar-reversed");
                $('#frontend-link').tooltip('destroy').tooltip({
                    placement: 'right'
                });
            } else {
                $(".body").removeClass("page-sidebar-reversed");
                $('#frontend-link').tooltip('destroy').tooltip({
                    placement: 'left'
                });
            }
        } else {
            if (sidebarPosOption === 'right') {
                $(".body").addClass("page-sidebar-reversed");
                $('#frontend-link').tooltip('destroy').tooltip({
                    placement: 'left'
                });
            } else {
                $(".body").removeClass("page-sidebar-reversed");
                $('#frontend-link').tooltip('destroy').tooltip({
                    placement: 'right'
                });
            }
        }

        Layout.fixContentHeight(); // fix content height            
        Layout.initFixedSidebar(); // reinitialize fixed sidebar

        if(this.initThemed)
			for(var prop in options){
				if(options.hasOwnProperty(prop))
					this.customizer.save("metronic/" + prop, options[prop]);;
			}
	};
	
	Model.prototype._openPage = function(path, options,fn){
		if(typeof options == 'function'){
			fn = options;
			options = {};
		}
		var me = this;
		options = options || {};
		var title = options.title || ''; 
		var pages = this.comp('pages'),
			url = this.getURL(path, options),
			pid = path.xid || path.url || url;
			pid = pid.replace(/bsessionid=[a-zA-Z0-9]+/g,'');
			if(pid.charAt(pid.length - 1) === "?" || pid.charAt(pid.length - 1) === "&"){
				pid = pid.substring(0,pid.length -1);
			}
			// 一个url配置多个菜单的情况特殊处理
			var matchMeuns = $('.page-sidebar-menu li>a[url="'+pid+'"]');
			var length = matchMeuns.length;
			if(length > 1){
				$.each(matchMeuns,function(index,value){
					var meunTitle = $(value).attr("title");
					if(meunTitle === title){
						pid = pid + "+" + index;
						return false;
					}
				});
			}
		if(!pages.has(pid)){
			this.loadPage(pid, url, options, function(err){
				if (err){
					setTimeout(function(){
						//hcr 特殊点, 必须知道错误对话框的btn
						$("#__justepErrorDialog__").find(".x-error-close").one("click", function(){
							setTimeout(function(){
								if (pages.getContent(pid))
									pages.getContent(pid).dispose();
							});
						}); 
					});
				}
				else{
					me.onOpenPage(pid, title);
				}
			});
			
			function after(){
				pages.to(pid,function(){
					fn && fn();
					me.subscribeChange();
				});
				me.setTitle(title);
				if(!me.openeds[pid]){
					var ppid = me.current && me.current.pid;
					me.current = justep.Util.clone(options);
					me.current.pid = pid;
					me.current.ppid = ppid;
					me.current.title = title;
					me.current.path = path;
					me.openeds[pid] = me.current; 
				}else{
					me.current = me.openeds[pid];  
				}
				if(pid === mainPageId)
					$(me.comp("closeFuncBtn").domNode).hide();
				else
					$(me.comp("closeFuncBtn").domNode).show();
			}
			after();
		}else{
			this.toPage(pid);
			fn && fn();
			this.subscribeChange();
		}
		return pid;
	};
	
	Model.prototype.toPage = function(pid, fn){
		var pages = this.comp('pages');
		var opened = this.openeds[pid];
		if(opened){
			this.setTitle(opened.title);
			pages.to(pid);
			this.current = opened;  

			if(pid === mainPageId)
				$(this.comp("closeFuncBtn").domNode).hide();
			else
				$(this.comp("closeFuncBtn").domNode).show();
		}
	};

	Model.prototype.hasPage = function(pid){
		var pages = this.comp('pages');
		var opened = this.openeds[pid];
		return !!opened;
	};
	
	Model.prototype.getPageId = function(){
		return this.current && this.current.pid;
	};
	
	Model.prototype.closePage = function(pid){
		var pages = this.comp('pages');
		if(pid){
			var fn = this.openeds[pid];
			var ppid = fn.ppid;
			delete this.openeds[pid];
			if(fn == this.current){
				if(ppid && this.openeds[ppid]){
					pages.remove(pid, ppid);
					this.current = this.openeds[ppid];
				}else{
					pages.remove(pid);
					this.current = this.openeds[mainPageId];
				}
			}else{
				pages.remove(pid, this.current.pid);
			}
			this.setTitle(this.current.title);
			this.onClosePage(pid);
		}else if(this.current && this.current.pid != mainPageId){
			pid = this.current.pid;
			var ppid = this.current.ppid;
			delete this.openeds[pid];
			if(ppid && this.openeds[ppid]){
				pages.remove(pid, ppid);
				this.current = this.openeds[ppid];
			}else{
				pages.remove(pid);
				this.current = this.openeds[mainPageId];
			}
			this.setTitle(this.current.title);
			this.onClosePage(pid);
		}
	};
	
	Model.prototype.onOpenPage = function(pid, title){
		if(pid != mainPageId){
			$('#portal-opened').show();
			var html = justep.String.format('<li><a data-pid="{0}" onmouseover="$(this).addClass(\'on\');" onmouseout="$(this).removeClass(\'on\');"><i class="opened-close pull-right icon-close-round"></i>{1}</a></li>', pid, title);
			$('#portal-opened .dropdown-menu').append(html);
		}	
	};
	
	Model.prototype.onClosePage = function(pid){
		if(this.current.pid == mainPageId)
			$(this.comp("closeFuncBtn").domNode).hide();
		$('#portal-opened .dropdown-menu li a').each(function(){
			if($(this).data('pid') == pid) $(this).parent().remove();
		});
		if($('#portal-opened .dropdown-menu li').length == 0)
			$('#portal-opened').hide();
	};
		
	Model.prototype.clear = function(){
		var pages = this.comp('pages');
		var self = this;
		pages.to(mainPageId, function(){
			self.setTitle("首页");
			pages.removeOther();
		});
		$('#portal-opened').hide();
		$('#portal-opened .dropdown-menu').html('');
	};
		
	
	Model.prototype.setTitle = function(value){
		value = value || "";
		$('.page-title').html(value);
	};
	
	
	Model.prototype.createFunctionTree = function(){

		var funcsData = this.getContext().data.functionTree.menu,
			$content = $(".page-sidebar-menu"),
			html = [];
	
		//html.push('<li><a href="#" isMain="true"><i class="fa fa-th-large" /><span class="nav-label">首页</span></a></li>');
	
		function printTree(children, isFirst){
			if(!children || !children.length) return;
			for(var i=0; i<children.length; i++){
				html.push('<li>');
				var child = children[i];
				html.push('<a class="ajaxify"');
				if(child.url){
					html.push('title="', child.label, '" ');
					html.push('activity="', child.activity, '" ');
					html.push('process="', child.process, '" ');
					var url = child.url;
					if(url[0] !== '$' && url[0] === '/')
						url = '$model' + url;
					html.push('url="', url, '" ');
				}
				html.push('>');
				if(child.iconClass)
					html.push('<i class="' + child.iconClass + '"/>');
				if(isFirst){
					html.push('<span class="title">');
				}
				html.push(child.label);
				if(isFirst){
					html.push('</span>');
					html.push('<span class="selected"></span>');
				}
				if(child.$children && child.$children.length > 0){
					html.push('<span class="arrow"></span>');
				}
				html.push('</a>');
				if(child.$children && child.$children.length > 0){
					html.push('<ul class="sub-menu">');
					printTree(child.$children);
					html.push('</ul>');
				}	
				html.push('</li>');
			}
		}
		
		printTree(funcsData.$children, true);
		
		html = html.join('');
		
		$content.append(html);
		
		var me = this;
	    $('li>a', $content).click(function(){
	    	var el = $(this);
	    	if(el.attr('url')){
	    		$(".func-open", $content).removeClass("func-open");
	    		el.parent().addClass("func-open");
	    		me.openPage({
	    			url: el.attr('url'),
	    			activity: el.attr('activity'),
	    			process: el.attr('process')
	    		}, {title: el.attr('title')});
	    	}else if(el.attr('isMain')){
	    		$(".func-open", $content).removeClass("func-open");
	    		me.toPage(mainPageId);
	    	}
	    });
	};

	Model.prototype.getURL = function(url, args){
		
		if(!url) return;
		if(typeof url !== 'string'){
			args = justep.Util.clone(url);//TODO clone;
			url = args.url;
			delete args.url;
		}
		args = args || {};
		if(url && url.indexOf("http")!==0){
			//args.language = args.language || this.getLanguage();
			//args.skin = args.skin || this.getSkin();
			args.bsessionid = this.bsessionid;
			var params = [];
			for(var key in args){
				if(args.hasOwnProperty(key))
					params.push(key + '=' + (args[key] || ''));
			}
			params = params.join('&');
			url = url + (url.indexOf('?') == -1?'?':'&') + params;
			url = require.toUrl(url);
        }
        return url;
	};
	
	Model.prototype.reload = function(options){
		this.isReloadMode = true;
		this.setBsessionid(this.bsessionid);
		window.location.reload();
	};

	Model.prototype.clientLogout = function(){
	
	};
	
	Model.prototype.showLoginDialog = function(){
		this.beforeLogin();
		var self = this;
		/*setTimeout(function(){
			self.comp("login").open();
		},500);*/
		this.comp("login").open();
	};
	
	Model.prototype.beforeLogin = function(){
		$(".page-header-inner .page-logo .menu-toggler").hide();
		$(".page-header-inner .top-menu").hide();

		$('#portal-opened').hide();
		$('#portal-opened .dropdown-menu').html('');
		
		$(".page-sidebar-menu>li").each(function(index, item){
			if(index>1) $(item).remove();
		});
		if(this.comp("pages")){
			this.comp("pages").removeAll();
		};
		
		$("#portal-agent").hide();
		$('#portal-agent .dropdown-menu').html('');
		
		this.setBsessionid(null);
	};
	
	Model.prototype.afterLogin = function(){
		var context = this.getContext();
		this.customizer = new Customizer(context.data.layout, context);
		this.initTheme();

		var me = this, pages = this.comp('pages');

		this.isDebugMode = context.isDebug();
		
		if(this.isDebugMode){
			$("#portal-reload").show();
		}	
		
		$(".page-header-inner .page-logo .menu-toggler").show();
		$(".page-header-inner .top-menu").show();

		//初始化用户名
		var userName = context.getCurrentPersonName();
		$("#username").html(userName);

		//初始化功能树
		this.createFunctionTree();

		this.openeds = {};
		this.current = this.openeds[mainPageId] = {title: '首页', pid: mainPageId};
		
		//加载主页面
		this.openPage({
				url: this.getURL(mainPage),
				xid: mainPageId
			}, {title: '首页'});
		
		//初始当前页
		var current = getParameter('current');
		if(current && current.path){
			var path = current.path;
			delete current.path;
			this.openPage(path, current);
		}else if(current){
			this.openPage(current);
		}
		
		//初始化代理
		var agentList = context.data.agentList;
		if(agentList && agentList.value && agentList.value.length > 0){
			var agents = context.data.agentList.value;
			var html = [];
			for(var i=0; i<agents.length; i++){
				var agent = agents[i];
				var s = justep.String.format('<li><a data-executor="{0}">{1}</a></li>', agent.id, agent.name);
				html.push(s);
			}
			$('#portal-agent .dropdown-menu').append(html.join(''));
			//var me = this;
			$("#portal-agent").show().click(function(e){
				var executor = $(e.target).data("executor");
				executor && me.openAgent(executor);
			});
		}
		debugger;
		//this.getLoginInfo();	
	};
	
	
	
	//取得登陆者信息
	Model.prototype.getLoginInfo = function(event) {
	debugger;
		var personData = this.comp('personData');
		var params = new biz.Request.ActionParam();
		//alert(this.getContext().getCurrentPersonCode());
		//params.setString("ygkh", '20112041');
		params.setString("p1", '1');
		biz.Request.sendBizRequest({
			"context" : this.getContext(),
			"action" : "test",
			"async" : true,
			"parameters" : params,
			"callback" : function(resultData) {
				resultData.ignoreError = false;
				if (resultData.state) {
				debugger;
//					personData.loadData(resultData.response);
//					personData.refreshData();
//					alert(personData.count());
				alert(2);
				} else {
					throw new Error('取得登陆者信息失败！');
				}
			}
		});
		
		
//		 if(personData.count() === 1){
//			 alert('succ');
//			 //localStorage.setItem('');
//		 }else{
//			 alert('shibai!');
//		 }
	};
	
	Model.prototype.modelLoad = function(event){
		
		//兼容UI功能
		justep.Portal.isPortal2 = true;
		
		this.setBsessionid(justep.Util.getCookie("bsessionid"));

		//初始化Metronic
		Metronic.init(); // init metronic core componets
		Layout.init(); // init layout
		QuickSidebar.init(); // init quick sidebar
		Index.init();
		Index.initDashboardDaterange();
		Index.initJQVMAP(); // init index page's custom scripts
		Index.initCalendar(); // init index page's custom scripts
		Index.initCharts(); // init index page's custom scripts
		Index.initChat();
		Index.initMiniCharts();
		Metronic.addResizeHandler(function(){
			var value = $(".page-content>.x-contents").css("min-height");
			if(/px$/.test(value)){
				$(".portal-frame").height(value);
				$(".window.x-full-screen").height(value);
			}
		});
		
		var me = this, pages = this.comp('pages');
		
		//切换打开的功能
		$('#portal-opened').hide();
		$("#portal-opened .dropdown-menu").click(function(event){
			if($(event.target).hasClass('opened-close')){
				me.closePage($(event.target).parent().data('pid'));
			}else{
				me.toPage($(event.target).data('pid'));
			}
		});
		
		$("#portal-reload").click(function(){
			me.reload();
		});
		
		window.onunload = function(){
			if(me.logined && !me.isReloadMode && !me.executor){
				me.doLogout();
				me.setBsessionid(null);
			}
		};

		//如果不是IE9 , 可以设置onbeforeunload
		if(!justep.Browser.IE9){
			window.onbeforeunload = function(){
				if(me.logined && !me.isReloadMode && !me.isDebugMode)
					return "退出会导致未保存的数据丢失?";
			};
		}
		
		//兼容平板设备
		$(".dropdown-toggle[data-hover=dropdown]").click(function(){
			$(this).parent().addClass("open");
		})
		
		if(!justep.Browser.hasTouch){
	        $('[data-x5-hover="dropdown"]').not('.hover-initialized').each(function() {
	            $(this).dropdownHover();
	            $(this).addClass('hover-initialized');
	        });
		}
		this.initExecutor();
		var name = getParameter("username");
		var password = getParameter("password");
		if(password)
			password = password.toUpperCase();//大写MD5
		var isDirectLogin = name && password; 
		if(this.logined || isDirectLogin){
			if(this.loadPortalContext(name, password))
				this.afterLogin();
			else
	        	this.showLoginDialog();
		}else{
			this.showLoginDialog();
		}
	
	};
	
	Model.prototype.initExecutor = function(){
		this.executor = getParameter("executor");
		if(this.executor){
			var me = this;
			me.comp("configBtn").$domNode.hide();
			me.comp("changPasswordBtn").$domNode.hide();
			me.comp("logoutBtn").$domNode.hide();
			me.comp("closeBtn").$domNode.show();
		}
	};
	
	var loginAction = "$UI/portal/pc/portalLogin.j";
	
	Model.prototype.loadPortalContext = function(name, password){
		var url = new justep.URL(require.toUrl(loginAction));
		this.bsessionid && url.setParam({
			bsessionid: this.bsessionid 
		});
		this.executor && url.setParam({
			executor: this.executor 
		});
		name && password && url.setParam({
			username: name,
			password: password,
			loginDate: justep.Date.toString(new Date(), 'yyyy-MM-dd') 
		});
        var result = $.ajax({
            type: "GET",
            url: url.toString(),
            dataType: 'json',
            async: false,
            cache:false
        });
        var data = JSON.parse(result.responseText);
        if(data.flag)
        	this.setPortalContext(data.data);
        return data.flag;
	};
	
	
	function getParameter(name){
		var search = window.location.search;
		var params = {};
		search = search ? search : "";
		var hash = window.location.hash;
		if (hash && (hash.indexOf("=")!=-1)){
			search += "&" + hash.substring(1);
		}
		
		if (search.charAt(0) == "?"){
			search = search.substring(1);
		}
		search = decodeURIComponent(search);
		var items = search.split("&");
		for (var i=0; i<items.length; i++){
			var item = items[i];
			var index = item.indexOf("=");
			if (item && (index!=-1)){
				var key = item.substring(0, index),
					value = decodeURIComponent(item.substring(index+1));
				if(key.indexOf('.') == '-1')
					params[key] = value;
				else{
					key = key.split('.');
					var obj = params[key[0]] = params[key[0]] || {};
					for(var j = 1;j<key.length-1;j++){
						obj = obj[key[j]] = obj[key[j]] || {}; 
					}
					obj[key.pop()] = value;
				}
			}
		}
		return params[name];
	};

	Model.prototype.a1Click = function(event){
		this.comp("login").open();
	};
	
	Model.prototype.setBsessionid = function(value){
		this.bsessionid = value; 
		//set cookie bsessionid
		if(value === null)
			justep.Util.deleteCookie("bsessionid", '/');
		else
			justep.Util.addCookie("bsessionid", value, '/');
		this.logined = !!this.bsessionid;

		if(justep.Browser.IE9){
			if(this.logined){
				window.onbeforeunload = function(){
					return "退出会导致未保存的数据丢失?";
				};
			}else{
				//确保登陆也不会提示
				window.onbeforeunload = undefined;
			}
		}
		
		if(window.__justep.directConnectBiz){
			var bizFrame = $('#bSessionIDFrame');
			if($('#bSessionIDFrame').length == 0){
				bizFrame = $('<div style="width:0;height:0;font-size:0;overflow:hidden;"><iframe></iframe></div>').attr({id:'bSessionIDFrame'});
				$('body').append(bizFrame);
			}
			bizFrame.find('iframe').attr("src",'/BusinessServer/default.html#' + this.bsessionid);
		}
	};
	
	Model.prototype.loginDialogReceive = function(data){
		this.setPortalContext(data.data);
		this.afterLogin();
	};
	
	Model.prototype.setPortalContext = function(data){
		var context = this.getContext();
		context.data = data;
		window.__justep.__portalContext = context;
		this.setBsessionid(context.data.bsessionid);
		$(".page-root").show();
	};

	Model.prototype.logoutBtnClick = function(event){
		this.logout();
	};
	
	Model.prototype.closeBtnClick = function(event){
		window.close();
	};

	Model.prototype.closeFuncBtnClick = function(event){
		this.closePage();
	};

	Model.prototype.configBtnClick = function(event){
		this.comp("configDialog").open();
	};
	
	Model.prototype.openAgent = function(executor){
		var config = justep.Util.clone(agentIndex);
		config.executor = executor;
		var url = this.getURL(config);
		var opener = window.open(url, executor);
		this.openers.push(opener);
		return opener;
	};
	
	Model.prototype.closeAllAgent = function(executor){
		for(var i=0; i<this.openers.length; i++){
			this.openers[i].close();
		}
	};
	
	Model.prototype.changPasswordBtnClick = function(event){
		this.openPage({
				url: this.getURL("$UI/portal/pc/changePassword/changePassword.w"),
				xid: "changePassword"
			}, {title: '修改密码'});
	};

	var Customizer = function(config, context){
		$.extend(this, config);
		this.other = this.other || {};
		this.context = context;
		this.enableSave = true; //TODO: justep.Portal.agentInfo;
	};
	
	Customizer.prototype = {
		doSave: function(key, data){
			if(!this.enableSave) return;
			var params = new biz.Request.ActionParam();
			params.setString(key, JSON.stringify(data));
			params.setString('personID', justep.Context.getCurrentPersonID());
			var action = key ==='functree'? "saveFunctreeAction" : "savePortalAction";
			var response = biz.Request.sendBizRequest({
				contentType: "application/json",
				dataType: "application/json",
				process : "/portal2/process/portal/portalProcess",
				activity : "index",
				action: action,
				parameters: params,
				context: this.context
			});
			if(!biz.Request.isSuccess(response)){
				var msg = new justep.Message(justep.Message.JUSTEP233000, key);
				throw justep.Error.create(msg);
		    }
		},
		saveFunctree: function(data){
			this.doSave("functree", data);
		},
		savePortal: function(data){
			this.doSave("portal", data);
		},
		save: function(key, data){
			if(!this.enableSave) return;
			this.other[key] = data; 
			var params = new biz.Request.ActionParam();
			params.setString("other", JSON.stringify(this.other));
			params.setString('personID', this.context.getCurrentPersonID());
			var response = biz.Request.sendBizRequest({
				contentType: "application/json",
				dataType: "application/json",
				process : "/portal2/process/portal/portalProcess",
				activity : "index",
				action: "saveOtherAction",
				parameters: params,
				context: this.context
			});
			if(!biz.Request.isSuccess(response)){
				var msg = new justep.Message(justep.Message.JUSTEP233000, key);
				throw justep.Error.create(msg);
		    }
		},
		get: function(key){
			return this.other[key];
		}
		
	};
	
	return Model;
});